## xmrig-mo 6.24.0%2Bdfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(xmrig)

option(WITH_HWLOC           "Enable hwloc support" ON)
option(WITH_CN_LITE         "Enable CryptoNight-Lite algorithms family" ON)
option(WITH_CN_HEAVY        "Enable CryptoNight-Heavy algorithms family" ON)
option(WITH_CN_PICO         "Enable CryptoNight-Pico algorithm" ON)
option(WITH_CN_FEMTO        "Enable CryptoNight-UPX2 algorithm" ON)
option(WITH_CN_GPU          "Enable CryptoNight-GPU algorithm" ON)
option(WITH_RANDOMX         "Enable RandomX algorithms family" ON)
option(WITH_ARGON2          "Enable Argon2 algorithms family" ON)
option(WITH_KAWPOW          "Enable KawPow algorithms family" ON)
option(WITH_GHOSTRIDER      "Enable GhostRider algorithm" ON)
option(WITH_HTTP            "Enable HTTP protocol support (client/server)" ON)
option(WITH_DEBUG_LOG       "Enable debug log output" OFF)
option(WITH_TLS             "Enable OpenSSL support" ON)
option(WITH_ASM             "Enable ASM PoW implementations" ON)
option(WITH_MSR             "Enable MSR mod & 1st-gen Ryzen fix" ON)
option(WITH_ENV_VARS        "Enable environment variables support in config file" ON)
option(WITH_EMBEDDED_CONFIG "Enable internal embedded JSON config" OFF)
option(WITH_OPENCL          "Enable OpenCL backend" ON)
set(WITH_OPENCL_VERSION 200 CACHE STRING "Target OpenCL version")
set_property(CACHE WITH_OPENCL_VERSION PROPERTY STRINGS 120 200 210 220)
option(WITH_CUDA            "Enable CUDA backend" ON)
option(WITH_NVML            "Enable NVML (NVIDIA Management Library) support (only if CUDA backend enabled)" ON)
option(WITH_ADL             "Enable ADL (AMD Display Library) or sysfs support (only if OpenCL backend enabled)" ON)
option(WITH_STRICT_CACHE    "Enable strict checks for OpenCL cache" ON)
option(WITH_INTERLEAVE_DEBUG_LOG "Enable debug log for threads interleave" OFF)
option(WITH_MO_BENCHMARK    "Enable Benchmark module and algo-perf feature (for MoneroOcean)" ON)
option(WITH_PROFILING       "Enable profiling for developers" OFF)
option(WITH_SSE4_1          "Enable SSE 4.1 for Blake2" ON)
option(WITH_AVX2            "Enable AVX2 for Blake2" ON)
option(WITH_VAES            "Enable VAES instructions for Cryptonight" ON)
option(WITH_BENCHMARK       "Enable builtin RandomX benchmark and stress test" ON)
option(WITH_SECURE_JIT      "Enable secure access to JIT memory" OFF)
option(WITH_DMI             "Enable DMI/SMBIOS reader" ON)

option(BUILD_STATIC         "Build static binary" OFF)
option(ARM_V8               "Force ARMv8 (64 bit) architecture, use with caution if automatic detection fails, but you sure it may work" OFF)
option(ARM_V7               "Force ARMv7 (32 bit) architecture, use with caution if automatic detection fails, but you sure it may work" OFF)
option(HWLOC_DEBUG          "Enable hwloc debug helpers and log" OFF)


set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake")


include (CheckIncludeFile)
include (cmake/cpu.cmake)
include (cmake/os.cmake)
include (src/base/base.cmake)
include (src/backend/backend.cmake)


set(HEADERS
    "${HEADERS_BASE}"
    "${HEADERS_BASE_HTTP}"
    "${HEADERS_BACKEND}"
    src/App.h
    src/core/config/Config_default.h
    src/core/config/Config_platform.h
    src/core/config/Config.h
    src/core/config/ConfigTransform.h
    src/core/config/usage.h
    src/core/Controller.h
    src/core/Miner.h
    src/core/Taskbar.h
    src/net/interfaces/IJobResultListener.h
    src/net/JobResult.h
    src/net/JobResults.h
    src/net/Network.h
    src/net/strategies/DonateStrategy.h
    src/Summary.h
    src/version.h
   )

set(HEADERS_CRYPTO
    src/backend/common/interfaces/IMemoryPool.h
    src/crypto/cn/asm/CryptonightR_template.h
    src/crypto/cn/c_blake256.h
    src/crypto/cn/c_groestl.h
    src/crypto/cn/c_jh.h
    src/crypto/cn/c_skein.h
    src/crypto/cn/CnAlgo.h
    src/crypto/cn/CnCtx.h
    src/crypto/cn/CnHash.h
    src/crypto/cn/CryptoNight_monero.h
    src/crypto/cn/CryptoNight_test.h
    src/crypto/cn/CryptoNight.h
    src/crypto/cn/groestl_tables.h
    src/crypto/cn/hash.h
    src/crypto/cn/skein_port.h
    src/crypto/cn/soft_aes.h
    src/crypto/common/HugePagesInfo.h
    src/crypto/common/MemoryPool.h
    src/crypto/common/Nonce.h
    src/crypto/common/portable/mm_malloc.h
    src/crypto/common/VirtualMemory.h
   )

if (XMRIG_ARM)
    set(HEADERS_CRYPTO "${HEADERS_CRYPTO}" src/crypto/cn/CryptoNight_arm.h)
else()
    set(HEADERS_CRYPTO "${HEADERS_CRYPTO}" src/crypto/cn/CryptoNight_x86.h)
endif()

set(SOURCES
    "${SOURCES_BASE}"
    "${SOURCES_BASE_HTTP}"
    "${SOURCES_BACKEND}"
    src/App.cpp
    src/core/config/Config.cpp
    src/core/config/ConfigTransform.cpp
    src/core/Controller.cpp
    src/core/Miner.cpp
    src/core/Taskbar.cpp
    src/net/JobResults.cpp
    src/net/Network.cpp
    src/net/strategies/DonateStrategy.cpp
    src/Summary.cpp
    src/xmrig.cpp
   )

set(SOURCES_CRYPTO
    src/crypto/cn/c_blake256.c
    src/crypto/cn/c_groestl.c
    src/crypto/cn/c_jh.c
    src/crypto/cn/c_skein.c
    src/crypto/cn/CnCtx.cpp
    src/crypto/cn/CnHash.cpp
    src/crypto/common/HugePagesInfo.cpp
    src/crypto/common/MemoryPool.cpp
    src/crypto/common/Nonce.cpp
    src/crypto/common/VirtualMemory.cpp
    src/crypto/flex/flex.cpp
    src/crypto/flex/flex_keccak.c
   )

if (WITH_MO_BENCHMARK)
    list(APPEND SOURCES
        src/core/MoBenchmark.cpp
        )
    add_definitions(/DXMRIG_FEATURE_MO_BENCHMARK)
endif()

if (CMAKE_C_COMPILER_ID MATCHES GNU)
    set_source_files_properties(src/crypto/cn/CnHash.cpp PROPERTIES COMPILE_FLAGS "-Ofast -fno-tree-vectorize")
endif()

if (WITH_VAES)
    add_definitions(-DXMRIG_VAES)
    set(HEADERS_CRYPTO "${HEADERS_CRYPTO}" src/crypto/cn/CryptoNight_x86_vaes.h)
    set(SOURCES_CRYPTO "${SOURCES_CRYPTO}" src/crypto/cn/CryptoNight_x86_vaes.cpp)
    if (CMAKE_C_COMPILER_ID MATCHES GNU OR CMAKE_C_COMPILER_ID MATCHES Clang)
        set_source_files_properties(src/crypto/cn/CryptoNight_x86_vaes.cpp PROPERTIES COMPILE_FLAGS "-Ofast -fno-tree-vectorize -mavx2 -mvaes")
    endif()
endif()

if (WITH_HWLOC)
    list(APPEND HEADERS_CRYPTO
        src/crypto/common/NUMAMemoryPool.h
        )

    list(APPEND SOURCES_CRYPTO
        src/crypto/common/NUMAMemoryPool.cpp
        src/crypto/common/VirtualMemory_hwloc.cpp
        )
endif()

if (XMRIG_OS_WIN)
    list(APPEND SOURCES_OS
        res/app.rc
        src/App_win.cpp
        src/crypto/common/VirtualMemory_win.cpp
        )

    set(EXTRA_LIBS ws2_32 psapi iphlpapi userenv dbghelp ole32 oleaut32)
elseif (XMRIG_OS_APPLE)
    list(APPEND SOURCES_OS
        src/App_unix.cpp
        src/crypto/common/VirtualMemory_unix.cpp
        )

    find_library(IOKIT_LIBRARY IOKit)
    find_library(CORESERVICES_LIBRARY CoreServices)
    set(EXTRA_LIBS ${IOKIT_LIBRARY} ${CORESERVICES_LIBRARY})
else()
    list(APPEND SOURCES_OS
        src/App_unix.cpp
        src/crypto/common/VirtualMemory_unix.cpp
        )

    if (XMRIG_OS_ANDROID)
        set(EXTRA_LIBS pthread rt dl log)
    elseif (XMRIG_OS_LINUX)
        list(APPEND SOURCES_OS
            src/crypto/common/LinuxMemory.h
            src/crypto/common/LinuxMemory.cpp
            )

        set(EXTRA_LIBS pthread rt dl)
    elseif (XMRIG_OS_FREEBSD)
        set(EXTRA_LIBS kvm pthread)
    endif()
endif()

add_definitions(-DXMRIG_MINER_PROJECT -DXMRIG_JSON_SINGLE_LINE_ARRAY)
add_definitions(-D__STDC_FORMAT_MACROS -DUNICODE -D_FILE_OFFSET_BITS=64)

find_package(UV REQUIRED)

include(cmake/flags.cmake)
include(cmake/cn-gpu.cmake)
include(cmake/randomx.cmake)
include(cmake/argon2.cmake)
include(cmake/kawpow.cmake)
include(cmake/ghostrider.cmake)
include(cmake/OpenSSL.cmake)
include(cmake/asm.cmake)

if (WITH_CN_LITE)
    add_definitions(/DXMRIG_ALGO_CN_LITE)
endif()

if (WITH_CN_HEAVY)
    add_definitions(/DXMRIG_ALGO_CN_HEAVY)
endif()

if (WITH_CN_PICO)
    add_definitions(/DXMRIG_ALGO_CN_PICO)
endif()

if (WITH_CN_FEMTO)
    add_definitions(/DXMRIG_ALGO_CN_FEMTO)
endif()

if (WITH_EMBEDDED_CONFIG)
    add_definitions(/DXMRIG_FEATURE_EMBEDDED_CONFIG)
endif()

include(src/hw/api/api.cmake)
include(src/hw/dmi/dmi.cmake)

include_directories(src)
include_directories(src/3rdparty)
include_directories(${UV_INCLUDE_DIR})

if (WITH_DEBUG_LOG)
    add_definitions(/DAPP_DEBUG)
endif()

add_executable(${CMAKE_PROJECT_NAME} ${HEADERS} ${SOURCES} ${SOURCES_OS} ${HEADERS_CRYPTO} ${SOURCES_CRYPTO} ${SOURCES_SYSLOG} ${TLS_SOURCES} ${XMRIG_ASM_SOURCES})
target_link_libraries(${CMAKE_PROJECT_NAME} ${XMRIG_ASM_LIBRARY} ${OPENSSL_LIBRARIES} ${UV_LIBRARIES} ${EXTRA_LIBS} ${CPUID_LIB} ${ARGON2_LIBRARY} ${ETHASH_LIBRARY} ${GHOSTRIDER_LIBRARY})

if (WIN32)
    if (NOT ARM_TARGET)
        add_custom_command(TARGET ${CMAKE_PROJECT_NAME} POST_BUILD COMMAND ${CMAKE_COMMAND} -E copy_if_different "${CMAKE_SOURCE_DIR}/bin/WinRing0/WinRing0x64.sys" $<TARGET_FILE_DIR:${CMAKE_PROJECT_NAME}>)
    endif()

    add_custom_command(TARGET ${CMAKE_PROJECT_NAME} POST_BUILD COMMAND ${CMAKE_COMMAND} -E copy_if_different "${CMAKE_SOURCE_DIR}/scripts/benchmark_1M.cmd" $<TARGET_FILE_DIR:${CMAKE_PROJECT_NAME}>)
    add_custom_command(TARGET ${CMAKE_PROJECT_NAME} POST_BUILD COMMAND ${CMAKE_COMMAND} -E copy_if_different "${CMAKE_SOURCE_DIR}/scripts/benchmark_10M.cmd" $<TARGET_FILE_DIR:${CMAKE_PROJECT_NAME}>)
    add_custom_command(TARGET ${CMAKE_PROJECT_NAME} POST_BUILD COMMAND ${CMAKE_COMMAND} -E copy_if_different "${CMAKE_SOURCE_DIR}/scripts/pool_mine_example.cmd" $<TARGET_FILE_DIR:${CMAKE_PROJECT_NAME}>)
    add_custom_command(TARGET ${CMAKE_PROJECT_NAME} POST_BUILD COMMAND ${CMAKE_COMMAND} -E copy_if_different "${CMAKE_SOURCE_DIR}/scripts/solo_mine_example.cmd" $<TARGET_FILE_DIR:${CMAKE_PROJECT_NAME}>)
    add_custom_command(TARGET ${CMAKE_PROJECT_NAME} POST_BUILD COMMAND ${CMAKE_COMMAND} -E copy_if_different "${CMAKE_SOURCE_DIR}/scripts/rtm_ghostrider_example.cmd" $<TARGET_FILE_DIR:${CMAKE_PROJECT_NAME}>)
endif()

if (CMAKE_CXX_COMPILER_ID MATCHES Clang AND CMAKE_BUILD_TYPE STREQUAL Release AND NOT CMAKE_GENERATOR STREQUAL Xcode)
    add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD COMMAND ${CMAKE_STRIP} "$<TARGET_FILE:${CMAKE_PROJECT_NAME}>")
endif()

=== debian/changelog ===
xmrig-mo (6.24.0+dfsg-1) unstable; urgency=medium

  * Rename to xmrig-mo for different source (MoneroOcean).
  * Changed rules in order to clean fmt and rapidjson when needed.
  * Changed control file. Perhaps more changes are needed, feel free to mention to me.

 -- Giovanni Santini <giovannisantini93@yahoo.it>  Thu, 14 Aug 2025 12:06:42 +0200

xmrig (6.24.0+dfsg-2) unstable; urgency=medium

  * Fix armhf build on ARMv8.

 -- Ben Westover <me@benthetechguy.net>  Tue, 24 Jun 2025 15:42:26 -0400

xmrig (6.24.0+dfsg-1) unstable; urgency=medium

  * New upstream version.

 -- Ben Westover <me@benthetechguy.net>  Mon, 23 Jun 2025 22:44:26 -0400

xmrig (6.23.0+dfsg-2) unstable; urgency=medium

  * Fix build on armhf.

 -- Ben Westover <me@benthetechguy.net>  Wed, 18 Jun 2025 16:52:26 -0400

xmrig (6.23.0+dfsg-1) unstable; urgency=medium

  * New upstream version.

 -- Ben Westover <me@benthetechguy.net>  Tue, 17 Jun 2025 21:22:12 -0400

xmrig (6.22.3+dfsg-1) unstable; urgency=medium

  * New upstream version.

 -- Ben Westover <me@benthetechguy.net>  Wed, 04 Jun 2025 15:16:17 -0400

xmrig (6.22.2+dfsg-2) unstable; urgency=medium

  * Fix FTBFS with fmtlib 10 (Fixes: #1086567)

 -- Ben Westover <me@benthetechguy.net>  Thu, 02 Jan 2025 15:40:14 -0500

xmrig (6.22.2+dfsg-1) unstable; urgency=medium

  * New upstream version.

 -- Ben Westover <me@benthetechguy.net>  Wed, 06 Nov 2024 22:54:24 -0500

xmrig (6.22.1+dfsg-1) unstable; urgency=medium

  * New upstream version.

 -- Ben Westover <me@benthetechguy.net>  Tue, 29 Oct 2024 23:32:22 -0400

xmrig (6.22.0+dfsg-1) unstable; urgency=medium

  * New upstream version.

 -- Ben Westover <me@benthetechguy.net>  Mon, 12 Aug 2024 13:23:33 -0400

xmrig (6.21.3+dfsg-1) unstable; urgency=medium

  * New upstream version.

 -- Ben Westover <me@benthetechguy.net>  Tue, 23 Apr 2024 11:42:12 -0400

xmrig (6.21.2+dfsg-2) unstable; urgency=medium

  * Forces ARMv7 build if on armhf architecture (Closes: #1066942)

 -- Ben Westover <me@benthetechguy.net>  Wed, 03 Apr 2024 13:22:12 -0400

xmrig (6.21.2+dfsg-1) unstable; urgency=medium

  * New upstream version.

 -- Ben Westover <me@benthetechguy.net>  Tue, 02 Apr 2024 16:26:12 -0400

xmrig (6.21.1+dfsg-1) unstable; urgency=medium

  * New upstream version.

 -- Ben Westover <me@benthetechguy.net>  Sun, 25 Feb 2024 14:54:45 -0500

xmrig (6.21.0+dfsg-1) unstable; urgency=medium

  * New upstream version.

 -- Ben Westover <me@benthetechguy.net>  Thu, 23 Nov 2023 12:02:20 -0500

xmrig (6.20.0+dfsg-1) unstable; urgency=medium

  * New upstream version.

 -- Ben Westover <me@benthetechguy.net>  Mon, 03 Jul 2023 19:24:12 -0400

xmrig (6.19.3+dfsg-1) unstable; urgency=medium

  * Initial Package (Closes: #1003917)

 -- Ben Westover <me@benthetechguy.net>  Sun, 04 Jun 2023 02:50:02 -0400

=== debian/control ===
Source: xmrig-mo
Section: utils
Priority: optional
Maintainer: Debian Cryptocoin Team <team+cryptocoin@tracker.debian.org>
Uploaders: Ben Westover <me@benthetechguy.net>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libstdc++6,
 libfmt-dev,
 libhwloc-dev,
 libssl-dev,
 libuv1-dev,
 opencl-c-headers,
 rapidjson-dev,
 help2man
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/cryptocoin-team/xmrig.git
Vcs-Browser: https://salsa.debian.org/cryptocoin-team/xmrig
Homepage: https://xmrig.com/
Rules-Requires-Root: no

Package: xmrig-mo
Architecture: i386 amd64 arm64 armhf
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: High performance, open source CPU/GPU miner and RandomX benchmark
 XMRig is a high performance, open source, cross platform RandomX, KawPow,
 CryptoNight, and GhostRider unified CPU/GPU miner and RandomX benchmark.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

%:
	dh $@

override_dh_auto_configure:
	-test -d src/3rdparty/fmt/ && rm -r src/3rdparty/fmt/ && ln -s /usr/include/fmt src/3rdparty/fmt
	-test -d src/3rdparty/rapidjson && rm -r src/3rdparty/rapidjson && ln -s /usr/include/rapidjson src/3rdparty/rapidjson
	dh_auto_configure -- -DWITH_KAWPOW=OFF

override_dh_clean:
	-dh_clean

execute_before_dh_auto_build:
	# blhc is triggered by the lack of -D_FORTIFY_SOURCE=2 in the
	# assembler flags. The flag does not affect assembly, so this
	# is a false positive. This line tells blhc to ignore assembly.
	@echo "blhc: ignore-line-regexp: /usr/(bin|lib/ccache)/cc.*\S+\.S"

execute_before_dh_installman:
	help2man -s 1 -n "CPU/GPU cryptocurrency miner" debian/xmrig-mo/usr/bin/xmrig > debian/xmrig.1
